/* $Id$ */
import std.string;
import SDL;
import SDL_ttf;
import SDL_mixer;
import SDL_image;
import SDL_net;

/*
 * このプログラムは、実行すると、640x480の画面を開き、BGMを流し、
 * http://google.com/ と通信を行い、
 * 画面にttfフォントで文字を描画します。
 * それしかできません。
 * 飽きたら適当に終了させてください。
 */

/* このファイルは、以下のソースを元にしました。
 * - http://www5.atwiki.jp/yaruhara/pages/74.html#id_ad9a2db7
 *
 * 尚、このソースはまともに関数の返り値のエラーチェックを行っていない為、
 * サンプルとしては極めて不適切。
 * 実際にコードを書く際には、必ず関数の返り値のエラーチェックを行う事！
 *
 */

void main()
{
  // 初期化ー
  if( SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO) < 0 ) {
    throw new Error("Couldn't initialize SDL");
  }
  // 640x480で。デフォルトのbpp。ソフトウェアで頑張る
  SDL_Surface *screen = SDL_SetVideoMode(640, 480, 0, SDL_SWSURFACE);
  if ( screen == null ) {
    throw new Error("Couldn't set 640x480 video mode");
  }

  SDL_Surface* icon = IMG_Load("data/images/icon.bmp");
  SDL_LockSurface(icon);
  SDL_SetColorKey(icon, SDL_SRCCOLORKEY, 15);
  SDL_UnlockSurface(icon);
  SDL_WM_SetIcon(icon, null);

  Mix_OpenAudio(22050, AUDIO_S16SYS, 2, 4096);
  Mix_Music *music = Mix_LoadMUS("data/sounds/Moonlight_Sonata.ogg");
  if (Mix_PlayMusic(music, 1) < 0) {
    throw new Error("failed bgm");
  }

  SDLNet_Init();
  IPaddress addr;
  SDLNet_ResolveHost(&addr, "google.com", 80);
  TCPsocket sock = SDLNet_TCP_Open(&addr);
  char[] req = "GET / HTTP/1.0\r\n\r\n";
  SDLNet_TCP_Send(sock, toStringz(req), req.length);
  char buf[1024+1];
  buf[1024] = 0;
  char *buf_ptr = &buf[0];
  SDLNet_TCP_Recv(sock, buf_ptr, 1024);
  SDLNet_TCP_Close(sock);
  char[][] ggls = splitlines(toString(buf_ptr));


  if( TTF_Init() < 0 ) {
    throw new Error("Couldn't initialize TTF");
  }
  TTF_Font *font = TTF_OpenFont("data/fonts/aqua2_8/aquafont.ttf", 24);
  SDL_Color color_white;
  color_white.r = 255;
  color_white.g = 255;
  color_white.b = 255;
  SDL_Surface *text = TTF_RenderUTF8_Blended(font, toStringz("ぐぐる: " ~ ggls[0]), color_white);
  SDL_BlitSurface(text, null, screen, null);


  // イベントループ
  bool done = false;
  SDL_Event e;
  while ( !done ) {
    while ( SDL_PollEvent(&e) ) {
      done = e.type == SDL_QUIT;
    }
    int numkeys;
    Uint8* keystate = SDL_GetKeyState(&numkeys);
    if (
        (keystate[SDLK_LALT] || keystate[SDLK_RALT])
        &&
        keystate[SDLK_F4]
       ) {
      done = true;
    }

    SDL_Delay(1000/30);
  }
  SDL_Quit();
}


/* vim:set ft=d sw=2 ts=8 sts=2 et: */
